program katju88;

uses
//  MemCheck,
  Forms,
  Windows,
  Messages,
  SysUtils,
  untMainForm in 'GUI\untMainForm.pas' {MainForm},
  untTool in 'Gadget\untTool.pas',
  untBoard in 'MainUnit\untBoard.pas',
  untTopicBrowser in 'TopicBrowser\untTopicBrowser.pas',
  untGlobal in 'MainUnit\untGlobal.pas',
  untBoardList in 'MainUnit\untBoardList.pas',
  untUpdateBoardForm in 'GUI\untUpdateBoardForm.pas' {UpdateBoardListForm},
  untTopic in 'MainUnit\untTopic.pas',
  crc in 'Gadget\crc.pas',
  gzip in 'Gadget\gzip.pas',
  zlib in 'Gadget\zlib.pas',
  untWriteForm in 'GUI\untWriteForm.pas' {WriteForm},
  untSearchForm in 'GUI\untSearchForm.pas' {SearchForm},
  untStreamTool in 'Gadget\untStreamTool.pas',
  DzURL in 'Gadget\DzURL.pas',
  untBBSCore in 'MainUnit\untBBSCore.pas',
  untTopicPostThread in 'Task\untTopicPostThread.pas',
  bmRegExp in 'Gadget\bmRegExp.pas',
  unt2chUrlParser in 'Gadget\unt2chUrlParser.pas',
  untTopicBrowserDoe in 'TopicBrowser\untTopicBrowserDoe.pas',
  untTopicBrowserIE in 'TopicBrowser\untTopicBrowserIE.pas',
  HogeTextView in 'Jane\HogeTextView.pas',
  untDoeSUB in 'Jane\untDoeSUB.pas',
  StrSub in 'Jane\StrSub.pas',
  untBBSSub in 'MainUnit\untBBSSub.pas',
  RegExpr in 'Gadget\RegExpr.pas',
  HTMLDocumentEvent in 'Gadget\HTMLDocumentEvent.pas',
  untFolderAlias in 'MainUnit\untFolderAlias.pas',
  untJaneConfig in 'Jane\untJaneConfig.pas',
  jconvert in 'JConvert\jconvert.pas',
  untBBSFramework in 'BBSFramework\untBBSFramework.pas',
  untBBS2ch in 'BBSFramework\untBBS2ch.pas',
  untHintWindow in 'Gadget\untHintWindow.pas',
  untBBSJBBS in 'BBSFramework\untBBSJBBS.pas',
  Dolib in 'BBSFramework\Dolib.pas',
  untLoginForm in 'GUI\untLoginForm.pas' {LoginForm},
  untBBS2chDolib in 'BBSFramework\untBBS2chDolib.pas',
  untDolibLogin in 'MainUnit\untDolibLogin.pas',
  UCrypt in 'Jane\UCrypt.pas',
  untCrypt in 'Gadget\untCrypt.pas',
  UBase64 in 'Jane\UBase64.pas',
  untBBS2chKako in 'BBSFramework\untBBS2chKako.pas',
  untTopicListView in 'GUI\untTopicListView.pas',
  untCreateOfflineFolder in 'GUI\untCreateOfflineFolder.pas' {CreateOfflineFolderForm},
  untAllSubscribedTopicsLoadThread in 'Task\untAllSubscribedTopicsLoadThread.pas',
  untEditBoardButttonForm in 'GUI\untEditBoardButttonForm.pas' {EditBoardButtonForm},
  untLogSweeper in 'MainUnit\untLogSweeper.pas',
  untLogSweeperForm in 'GUI\untLogSweeperForm.pas' {LogSweeperForm},
  untImageListTool in 'Gadget\untImageListTool.pas',
  untColorButton in 'GUI\untColorButton.pas',
  untKakikomi in 'MainUnit\untKakikomi.pas',
  USynchro in 'Jane\USynchro.pas',
  untConfig in 'Global\untConfig.pas',
  untHttp in 'Gadget\untHttp.pas',
  untLog in 'MainUnit\untLog.pas',
  untLogWatch in 'GUI\untLogWatch.pas' {Form1},
  untOptionForm in 'GUI\untOptionForm.pas' {OptionForm},
  UCryptAuto in 'Jane\UCryptAuto.pas';

{$R *.res}

procedure GetExceptInfoFunc(Obj: TObject; var Message: string;
    var ExceptionRecord: Windows.PExceptionRecord);
begin
  if Obj is Exception then
  begin
    Message := Exception(Obj).Message;
    if Obj is EExternal then
      ExceptionRecord := Windows.PExceptionRecord(EExternal(Obj).ExceptionRecord);
  end;
end;

procedure SetExceptMessageFunc(Obj: TObject; const NewMessage: string);
begin
  if Obj is Exception then
    Exception(Obj).Message := NewMessage;
end;

const
  hApp = 'katju88kid';

var
  hMutex: integer;
  wnd: integer;
  appWnd: integer;

begin

  //MemCheckInstallExceptionHandler(GetExceptInfoFunc, SetExceptMessageFunc);
  hMutex := OpenMutex(MUTEX_ALL_ACCESS, False, hApp);

  if hMutex <> 0 then
  begin
    wnd := FindWindow('TMainForm', nil);
    if wnd <> 0 then
    begin
      SetForegroundWindow(wnd);
      appWnd := GetWindowLong(wnd, GWL_HWNDPARENT);
      if (appWnd <> 0) and IsIconic(appWnd) then
      begin
        SendMessage(appWnd, WM_SYSCOMMAND, SC_RESTORE, -1);
      end;
    end;
    CloseHandle(hMutex);
  end else
  begin
    hMutex := CreateMutex(nil, False, hApp);

    Application.Initialize;

    DateSeparator   := '/';
    TimeSeparator   := ':';
    ShortDateFormat := 'yyyy/MM/dd';
    LongTimeFormat  := 'hh:nn:ss';
    Application.UpdateFormatSettings := False;

    Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TSearchForm, SearchForm);
  Application.CreateForm(TForm1, Form1);
  Application.CreateForm(TOptionForm, OptionForm);
  Application.Run;

    ReleaseMutex(hMutex);
  end
end.
